/* memory.h */

int ramext;
int quickvideo;

struct to8_status {
  int ramext;        /* 512kb RAM */
  int card;          /* rom card inserted */
  int bank;          /* ram bank */
  int selrama;       /* video ram sel */
  int selcart;       /* ext rom sel */
  int rampia;        /* ram sel by pia */
  int rombank;       /* user rom bank */
  int monbank;
  int romrampage;    /* rom masked by ram */
  int vidpage;       /* video page */
  int selreglp;      /* sel light pen regs */
  int piaaprb_datamode;
  tt_u8 piabpraout, piabprbout, piabprain, piabprbin, piabpramask, piabprbmask;
  tt_u8 piabcra, piabcrb;
  int piabpra_datamode, piabprb_datamode;
  tt_u16 timer_val;
  tt_u16 timer_val_init;
  int timer_enabled;
  int timer_irq;
  int timer_mode;
  int timer_readirq;
  int mute;
  int sellp;
  int lpx, lpy;
  tt_u8 regE7C1, regE7C3, regE7C5;
  tt_u8 regE7DC, regE7DD;
  tt_u8 regE7E6;
  tt_u8 regE7DB;
  tt_u8 colorreg[32];
  unsigned long truecolors[16];
};

extern tt_u16 memtrapaddr;
extern int memtrap;
extern int ktest;
extern struct to8_status status;

struct to8_save {
  /* 6809 registers */
  tt_u16 rpc, rx, ry, ru, rs;
  tt_u8 ra, rb, rdp, rcc;
  /* TO8 status */
  struct to8_status status;
};

/* Memory */

extern tt_u8 *ramdata;

/* prototypes */

void mem_dumpstate(void);
int load_rom(char *romfile);
int memory_init(char *romdirpath, char *romfile);
tt_u8 get_memb(tt_u16 adr);
tt_u16 get_memw(tt_u16 adr);
void set_memb(tt_u16 adr, tt_u8 val);
void set_memw(tt_u16 adr, tt_u16 val);
void install_trap(void);
void trap(void);
void record_key(char *buffer);
void memory_reset(void);
void timer_timeout(void);
int memory_load(char *filename);
int memory_save(char *filename);


